<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\Session\Session;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Util\Functions;
use Teknisa\MAN\Services\RelatoriosTabelaPrecoService;
use \Setforms2\Shared\ORM\DateTime;

use Teknisa\MAN\Utilities\Util;
use Teknisa\MAN\Services\ParamsProduto as ParamsProdutoService;


class RelatoriosTabelaPreco extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceManager;
    protected $environment;
    protected $crudService;
    protected $utilService;
    
    public function __construct($dataSourceManager, $crudService, $environment, Util $utilService, RelatoriosTabelaPrecoService $relatoriosTabelaPrecoService) {
        $this->dataSourceManager     = $dataSourceManager;
        $this->crudService           = $crudService;
        $this->environment           = $environment;
        $this->util                  = $utilService;
        $this->RelatoriosTabelaPrecoService = $relatoriosTabelaPrecoService;
    }
    
    public function getData(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSourceName = 'relatoriosTabelaPreco';
        
        try{
            $conditions = $this->util->getParamsAsArray($request);
            if(Functions::arrayKeyExists('DTINIVGPREC', $conditions)){
                if($conditions['DTINIVGPREC']){
                    if(!Functions::arrayKeyExists('CDFILIAL', $conditions)) {
                        $conditions['CDFILIAL'] = $conditions['CDFILIAL'];
                    }
                    if(!Functions::arrayKeyExists('CDLOJA', $conditions)) {
                        $conditions['CDLOJA'] = '';
                    }
                    if(!Functions::arrayKeyExists('DTINIVGPREC', $conditions)) {
                        $conditions['DTINIVGPREC'] = $conditions['DTINIVGPREC'];
                    }
                    if(!Functions::arrayKeyExists('NRORG', $conditions)) {
                        $conditions['NRORG'] = $conditions['NRORG'];
                    }
                    if(!Functions::arrayKeyExists('CDPRODUTOINI', $conditions)) {
                        $conditions['CDPRODUTOINI'] = $conditions['CDPRODUTOINI'];
                    }
                    if(!Functions::arrayKeyExists('CDPRODUTOFIN', $conditions)) {
                        $conditions['CDPRODUTOFIN'] = $conditions['CDPRODUTOFIN'];
                    }
                    if(!Functions::arrayKeyExists('CDTABEPREC', $conditions)) {
                        $conditions['CDTABEPREC'] = $conditions['CDTABEPREC'];
                    }
                    $response->addDataSet(new DataSet($dataSourceName,
                    $this->RelatoriosTabelaPrecoService->buscaDados($conditions['CDFILIAL'], $conditions['CDLOJA'], $conditions["CDPRODUTOINI"], $conditions["CDPRODUTOFIN"], $conditions["DTINIVGPREC"], $conditions["CDTABEPREC"], $conditions["NRORG"], $conditions['IDRELATORIO'])));
                    return $response;
                }
            }
            else {
                return $response;
            }
        
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function findVigenciasRel(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "select_tabelaprecovigenciasRel";
        parent::find($request, $response);
    }
   
}


